//+------------------------------------------------------------------+
//|                                                   #MTF Arrow.mq4 |
//|                                                  FOREX-AUSBILDER |
//|                                           www.forex-ausbilder.de |
//+------------------------------------------------------------------+
/*
  Change Log:
    2.01 2012 08 21 Changed the for loop inequality to include = 
    2.00 2012 08 15 Cody_R
                    Added externs for Up arrow/Dn arrow symbols
                    Added extern for arrow size
                    Added auto select of the next highest time frame
                    Set SoundAlarm default to off.
                    
*/
#property copyright "FOREX-AUSBILDER"
#property link      "www.forex-ausbilder.de"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Gold
//--- input parameters
extern int       TimeFramePeriod=0;        // Timeframe: 0,1,5,15,30,60,240,1440 etc. Current Timeframe=0. 
extern int       TimeFrameAuto=1;          // Automatically select higher TF. M15 and M30 -> H1. Off=0, 1st HTF=1, 2nd HTF=2
extern bool      SoundAlarm=false;
extern bool      EmailAlarm=false;
extern int       UpArrow = 233; //217; //225; //241;
extern int       DnArrow = 234; //218; //226; //242;
extern int       ArrowSize = 0;
//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   string short_name;
//---- indicator line
   
//---- name for DataWindow and indicator subwindow label   
   
      short_name="#MTF Arrow";
      
  // Set Timeframe
  switch(TimeFrameAuto) {
    case 1:
      TimeFramePeriod=NextHigherTF(TimeFramePeriod);
    break;
    case 2:
      TimeFramePeriod=NextHigherTF(NextHigherTF(TimeFramePeriod));
    break;
    default:
      if (TimeFramePeriod<1 || TimeFramePeriod==Period()) {
        TimeFramePeriod=Period();
      }
    break;
  }

    switch(TimeFramePeriod)
   {
      case 1 : string TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="M"+Period();
      
   }   
   SetIndexStyle(0,DRAW_ARROW,0,ArrowSize);
   SetIndexArrow(0,DnArrow);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW,0,ArrowSize);
   SetIndexArrow(1,UpArrow);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   IndicatorShortName(short_name+" "+TimeFrameStr);  
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFramePeriod); 
   
   limit=Bars-counted_bars+TimeFramePeriod/Period();
   
   for(i=0,y=0;i<=limit;i++)  // 2.01 change i< to i<=
   {
   if (Time[i]<TimeArray[y]) y++; 
   ExtMapBuffer1[i] = iCustom(NULL,TimeFramePeriod, "arrow", SoundAlarm, EmailAlarm, 0, y);
   ExtMapBuffer2[i] = iCustom(NULL,TimeFramePeriod, "arrow", SoundAlarm, EmailAlarm, 1, y);
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//-----------------------------------------------------------------------------
// function: NextHigherTF()
// Description: Select the next higher time-frame.
//              Note: M15 and M30 both select H1 as next higher TF.
//-----------------------------------------------------------------------------
int NextHigherTF(int iPeriod) {
  if (iPeriod==0) iPeriod=Period();
  switch(iPeriod) {
    case PERIOD_M1: return(PERIOD_M5);
    case PERIOD_M5: return(PERIOD_M15);
    case PERIOD_M15: return(PERIOD_H1);
    case PERIOD_M30: return(PERIOD_H1);
    case PERIOD_H1: return(PERIOD_H4);
    case PERIOD_H4: return(PERIOD_D1);
    case PERIOD_D1: return(PERIOD_W1);
    case PERIOD_W1: return(PERIOD_MN1);
    case PERIOD_MN1: return(PERIOD_MN1);
    default: return(Period());
  }
}

